//---------------------------------------------------------------------------
/*
	TVP2 ( T Visual Presenter 2 )  A script authoring tool
	Copyright (C) 2000 W.Dee <dee@kikyou.info> and contributors

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------
// Definition of Messages and Message Related Utilities
//---------------------------------------------------------------------------
#ifndef MsgIntfH
#define MsgIntfH

#include "tjs.h"
#include "tjsMessage.h"

#ifndef TVP_MSG_DECL
	#define TVP_MSG_DECL(name, msg) extern tTJSMessageHolder name;
	#define TVP_MSG_DECL_CONST(name, msg) extern tTJSMessageHolder name;
#endif

#include "MsgImpl.h"
#include "svn_revision.h"

//---------------------------------------------------------------------------
// Message Strings ( these should be localized )
//---------------------------------------------------------------------------
// Japanese localized messages
TVP_MSG_DECL_CONST(TVPAboutString,
	
TJS_W("gg[肫] 2 sRA version %1 ( TJS version %2 )\n")
TJS_W("Compiled on ") __DATE__ TJS_W(" ") __TIME__ TJS_W("\n")
TJS_W("SVN Revision: ") TVP_SVN_REVISION TJS_W("\n")
TJS_W("Copyright (C) 1997-2012 W.Dee and contributors All rights reserved.\n")
TJS_W("Contributors in alphabetical order:\n")
TJS_W("  Go Watanabe, Kenjo, Kiyobee, Kouhei Yanagita, mey, MIK, Takenori Imoto, yun\n")
TJS_W("ggsRA̎gp/zz/ς́A\n")
TJS_W("SDK t license.txt ɏĂ郉CZXɏ]čsƂł܂.\n")
TJS_W("------------------------------------------------------------------------------\n")
TJS_W("Thanks for many libraries, contributers and supporters not listible here.\n")
TJS_W("This software is based in part on the work of Independent JPEG Group.\n")
TJS_W("Regex++ Copyright (c) 1998-2003 Dr John Maddock\n")
TJS_W("ERINA-Library Copyright (C) 2001 Leshade Entis, Entis-soft.\n")
TJS_W("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - \n")
TJS_W("Using \"A C-program for MT19937\"\n")
TJS_W("\n")
TJS_W("   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,\n")
TJS_W("   All rights reserved.\n")
TJS_W("\n")
TJS_W("   Redistribution and use in source and binary forms, with or without\n")
TJS_W("   modification, are permitted provided that the following conditions\n")
TJS_W("   are met:\n")
TJS_W("\n")
TJS_W("     1. Redistributions of source code must retain the above copyright\n")
TJS_W("        notice, this list of conditions and the following disclaimer.\n")
TJS_W("\n")
TJS_W("     2. Redistributions in binary form must reproduce the above copyright\n")
TJS_W("        notice, this list of conditions and the following disclaimer in the\n")
TJS_W("        documentation and/or other materials provided with the distribution.\n")
TJS_W("\n")
TJS_W("     3. The names of its contributors may not be used to endorse or promote\n")
TJS_W("        products derived from this software without specific prior written\n")
TJS_W("        permission.\n")
TJS_W("\n")
TJS_W("   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n")
TJS_W("   \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n")
TJS_W("   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n")
TJS_W("   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR\n")
TJS_W("   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,\n")
TJS_W("   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,\n")
TJS_W("   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\n")
TJS_W("   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\n")
TJS_W("   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\n")
TJS_W("   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n")
TJS_W("   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n")
TJS_W("------------------------------------------------------------------------------\n")
TJS_W("\n")
  // important log (environment information, Debug.notice etc.) comes here
);

TVP_MSG_DECL_CONST(TVPVersionInformation,
	
TJS_W("gg[肫] 2 sRA/%1 ")
TJS_W("(SVN revision:") TVP_SVN_REVISION TJS_W("; Compiled on ") __DATE__ TJS_W(" ") __TIME__ TJS_W(") TJS2/%2 ")
TJS_W("Copyright (C) 1997-2012 W.Dee and contributors All rights reserved."));

TVP_MSG_DECL_CONST(TVPVersionInformation2,
	TJS_W("o[W̏ڍׂ Ctrl + F12 ŉ{ł܂"));

TVP_MSG_DECL_CONST(TVPDownloadPageURL,
	TJS_W("http://kikyou.info/tvp/"));

TVP_MSG_DECL(TVPInternalError,
	TJS_W("G[܂: at %1 line %2"));

TVP_MSG_DECL(TVPInvalidParam,
	TJS_W("sȃp[^ł"));

TVP_MSG_DECL(TVPWarnDebugOptionEnabled,
	TJS_W("-debug IvVw肳Ă邽߁A gg̓fobO[hœ삵Ă܂BfobO[hł͏\ȎsxoȂꍇ̂ŒӂĂ"));

TVP_MSG_DECL(TVPCommandLineParamIgnoredAndDefaultUsed,
	TJS_W("R}hCp[^ %1 Ɏw肳ꂽl %2 ͖̂߃ftHg̐ݒp܂"));

TVP_MSG_DECL(TVPInvalidCommandLineParam,
	TJS_W("R}hCp[^ %1 Ɏw肳ꂽl %2 ͖ł"));

TVP_MSG_DECL(TVPNotImplemented,
	TJS_W("̋@\ĂяoƂ܂"));

TVP_MSG_DECL(TVPCannotOpenStorage,
	TJS_W("Xg[W %1 JƂł܂"));

TVP_MSG_DECL(TVPCannotFindStorage,
	TJS_W("Xg[W %1 ܂"));

TVP_MSG_DECL(TVPCannotOpenStorageForWrite,
	TJS_W("Xg[W %1 ݗpɊJƂł܂Bt@C݋֎~ɂȂĂȂA邢̓t@Cɏ݌邩ǂA邢͂ꂪ݉\ȃfBAt@CȂ̂mFĂ"));

TVP_MSG_DECL(TVPStorageInArchiveNotFound,
	TJS_W("Xg[W %1 A[JCu %2 ̒Ɍ܂"));

TVP_MSG_DECL(TVPInvalidPathName,
	TJS_W("pX %1 ͖Ȍ`łB`ǂmFĂ"));

TVP_MSG_DECL(TVPUnsupportedMediaName,
	TJS_W("\"%1\" ͑ΉĂȂfBA^Cvł"));

TVP_MSG_DECL(TVPCannotUnbindXP3EXE,
	TJS_W("%1 ͎s\t@CɌ܂AɌꂽA[JCu𔭌ł܂ł"));

TVP_MSG_DECL(TVPCannotFindXP3Mark,
	TJS_W("%1  XP3 A[JCuł͂ȂAΉłȂ`łBA[JCut@Cw肷ׂʂŒʏ̃t@Cw肵ꍇA邢͑ΉłȂA[JCut@Cw肵ꍇȂǂɂ̃G[܂̂ŁAmFĂ"));

TVP_MSG_DECL(TVPMissingPathDelimiterAtLast,
	TJS_W("pX̍Ōɂ '>' ܂ '/' w肵Ă (ggQ 2.19 beta 14 A[JCű؂L '#'  '>' ɕς܂)"));

TVP_MSG_DECL(TVPFilenameContainsSharpWarn,
	TJS_W("() '#' t@C \"%1\" Ɋ܂܂Ă܂BA[JCű؂蕶͋ggQ 2.19 beta 14 '#'  '>' ɕς܂B")
	TJS_W("A[JCű؂蕶̂ '#' gpꍇ́A萔ł '>' ɕςĂ"));

TVP_MSG_DECL(TVPCannotGetLocalName,
	TJS_W("Xg[W %1 [Jt@Cɕϊł܂BA[JCut@C̃t@CA[Jt@CłȂt@C̓[Jt@Cɕϊł܂B"));

TVP_MSG_DECL(TVPReadError,
	TJS_W("ǂݍ݃G[łBt@CjĂ\AfoCX̓ǂݍ݂Ɏs\܂"));

TVP_MSG_DECL(TVPWriteError,
	TJS_W("݃G[ł"));

TVP_MSG_DECL(TVPSeekError,
	TJS_W("V[NɎs܂Bt@CjĂ\AfoCX̓ǂݍ݂Ɏs\܂"));

TVP_MSG_DECL(TVPTruncateError,
	TJS_W("t@C̒؂l߂̂Ɏs܂"));

TVP_MSG_DECL(TVPInsufficientMemory,
	TJS_W("mۂɎs܂B"));

TVP_MSG_DECL(TVPUncompressionFailed,
	TJS_W("t@C̓WJɎs܂BΉ̈k`w肳ꂽA邢̓t@CjĂ\܂"));

TVP_MSG_DECL(TVPCompressionFailed,
	TJS_W("t@C̈kɎs܂"));

TVP_MSG_DECL(TVPCannotWriteToArchive,
	TJS_W("A[JCuɃf[^ނƂ͂ł܂"));

TVP_MSG_DECL(TVPUnsupportedCipherMode,
	TJS_W("%1 ͖Ή̈Í`Af[^jĂ܂"));

TVP_MSG_DECL(TVPUnsupportedModeString,
	TJS_W("FłȂ[h̎wł(%1)"));

TVP_MSG_DECL(TVPUnknownGraphicFormat,
	TJS_W("%1 ͖m̉摜`ł"));

TVP_MSG_DECL(TVPCannotSuggestGraphicExtension,
	TJS_W("%1 ɂēK؂Ȋgqt@C܂ł"));

TVP_MSG_DECL(TVPMaskSizeMismatch,
	TJS_W("}XN摜̃TCYC摜̃TCYƈႢ܂"));

TVP_MSG_DECL(TVPProvinceSizeMismatch,
	TJS_W("̈摜 %1 ̓C摜ƃTCYႢ܂"));

TVP_MSG_DECL(TVPImageLoadError,
	TJS_W("摜ǂݍݒɃG[܂/%1"));

TVP_MSG_DECL(TVPJPEGLoadError,
	TJS_W("JPEG ǂݍݒɃG[܂/%1"));

TVP_MSG_DECL(TVPPNGLoadError,
	TJS_W("PNG ǂݍݒɃG[܂/%1"));

TVP_MSG_DECL(TVPERILoadError,
	TJS_W("ERI ǂݍݒɃG[܂/%1"));

TVP_MSG_DECL(TVPTLGLoadError,
	TJS_W("TLG ǂݍݒɃG[܂/%1"));

TVP_MSG_DECL(TVPInvalidImageSaveType,
	TJS_W("ȕۑ摜`ł(%1)"));

TVP_MSG_DECL(TVPInvalidOperationFor8BPP,
	TJS_W("8bpp 摜ɑ΂Ă͍sȂsƂ܂"));

TVP_MSG_DECL(TVPSpecifyWindow,
	TJS_W("Window NX̃IuWFNgw肵Ă"));

TVP_MSG_DECL(TVPSpecifyLayer,
	TJS_W("Layer NX̃IuWFNgw肵Ă"));

TVP_MSG_DECL(TVPCannotCreateEmptyLayerImage,
	TJS_W("摜TCỶ邢͏c 0 ȉ̐ɐݒ肷邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPCannotSetPrimaryInvisible,
	TJS_W("vC}C͕sɂł܂"));

TVP_MSG_DECL(TVPCannotMovePrimary,
	TJS_W("vC}C͈ړł܂"));

TVP_MSG_DECL(TVPCannotSetParentSelf,
	TJS_W("geƂ邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPCannotMoveNextToSelfOrNotSiblings,
	TJS_W("g̑OëقȂ郌C̑OɈړ邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPCannotMovePrimaryOrSiblingless,
	TJS_W("vC}CZ̖C͑OɈړ邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPCannotMoveToUnderOtherPrimaryLayer,
	TJS_W("ʂ̃vC}CɃCړ邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPInvalidImagePosition,
	TJS_W("C̈ɉ摜̖̈悪܂"));

TVP_MSG_DECL(TVPCannotSetModeToDisabledOrModal,
	TJS_W("łɃ[_ȃC̐eCA邢͕s/ȃC[_ɂ邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPNotDrawableLayerType,
	TJS_W(" type ̃Cł͕`摜ǂݍ݂摜TCY/ʒu̕ύX/擾͂ł܂"));

TVP_MSG_DECL(TVPSourceLayerHasNoImage,
	TJS_W("]C͉摜Ă܂"));

TVP_MSG_DECL(TVPUnsupportedLayerType,
	TJS_W("%1 ͂ type ̃Cł͎gpł܂"));

TVP_MSG_DECL(TVPNotDrawableFaceType,
	TJS_W("%1 ł͂ face ɕ`ł܂"));

TVP_MSG_DECL(TVPCannotConvertLayerTypeUsingGivenDirection,
	TJS_W("w肳ꂽC^Cvῗł܂"));

TVP_MSG_DECL(TVPNegativeOpacityNotSupportedOnThisFace,
	TJS_W("̕sx͂ face ł͎wł܂"));

TVP_MSG_DECL(TVPSrcRectOutOfBitmap,
	TJS_W("]rbg}bvÖ̗܂ł܂B͈͂Ɏ܂悤ɓ]w肵Ă"));

TVP_MSG_DECL(TVPBoxBlurAreaMustContainCenterPixel,
	TJS_W("`u[͈͕̔͂K(0,0)̒Ɋ܂ޕKv܂BleftrightƂ̐lA邢͗Ƃ̐lƂw͂ł܂(topbottomɑ΂Ăl)"));

TVP_MSG_DECL(TVPBoxBlurAreaMustBeSmallerThan16Million,
	TJS_W("`u[͈̔͂傫܂B`u[͈̔͂1677ȉłKv܂"));

TVP_MSG_DECL(TVPCannotChangeFocusInProcessingFocus,
	TJS_W("tH[JXύX̓tH[JXVɕύX邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPWindowHasNoLayer,
	TJS_W("EBhEɃC܂"));

TVP_MSG_DECL(TVPWindowHasAlreadyPrimaryLayer,
	TJS_W("EBhEɂ͂łɃvC}C܂"));

TVP_MSG_DECL(TVPSpecifiedEventNeedsParameter,
	TJS_W("Cxg %1 ɂ̓p[^Kvł"));

TVP_MSG_DECL(TVPSpecifiedEventNeedsParameter2,
	TJS_W("Cxg %1 ɂ̓p[^ %2 Kvł"));

TVP_MSG_DECL(TVPSpecifiedEventNameIsUnknown,
	TJS_W("Cxg %1 ͖m̃Cxgł"));

TVP_MSG_DECL(TVPOutOfRectangle,
	TJS_W("`Ow肳܂"));

TVP_MSG_DECL(TVPInvalidMethodInUpdating,
	TJS_W("ʍXV͂̋@\sł܂"));

TVP_MSG_DECL(TVPCannotCreateInstance,
	TJS_W("̃NX̓CX^X쐬ł܂"));

TVP_MSG_DECL(TVPUnknownWaveFormat,
	TJS_W("%1 ͑ΉłȂ Wave `ł"));

TVP_MSG_DECL(TVPSpecifyMenuItem,
	TJS_W("MenuItem NX̃IuWFNgw肵Ă"));

TVP_MSG_DECL(TVPCurrentTransitionMustBeStopping,
	TJS_W("݂̃gWV~ĂVgWVJnĂBCɑ΂ĕ̃gWV𓯎Ɏs悤ƂƂ̃G[܂"));

TVP_MSG_DECL(TVPTransHandlerError,
	TJS_W("gWVnhŃG[܂ : %1"));

TVP_MSG_DECL(TVPTransAlreadyRegistered,
	TJS_W("gWV %1 ͊ɓo^Ă܂"));

TVP_MSG_DECL(TVPCannotFindTransHander,
	TJS_W("gWVnh %1 ܂"));

TVP_MSG_DECL(TVPSpecifyTransitionSource,
	TJS_W("gWVw肵Ă"));

TVP_MSG_DECL(TVPLayerCannotHaveImage,
	TJS_W("̃C͉摜Ƃ͂ł܂"));

TVP_MSG_DECL(TVPTransitionSourceAndDestinationMustHaveImage,
	TJS_W("gWVƃgWV͂Ƃɉ摜ĂKv܂"));

TVP_MSG_DECL(TVPCannotLoadRuleGraphic,
	TJS_W("[摜 %1 ǂݍނƂł܂"));

TVP_MSG_DECL(TVPSpecifyOption,
	TJS_W("IvV %1 w肵Ă"));

TVP_MSG_DECL(TVPTransitionLayerSizeMismatch,
	TJS_W("gWV(%1)ƃgWV(%2)̃C̃TCYv܂"));

TVP_MSG_DECL(TVPTransitionMutualSource,
	TJS_W("gWṼgWVgł"));

TVP_MSG_DECL(TVPHoldDestinationAlphaParameterIsNowDeprecated,
	TJS_W("x : \bh %1  %2 Ԗڂɓnꂽ hda p[^́AggQ 2.23 beta 2 薳悤ɂȂ܂B Layer.holdAlpha vpeBpĂB"));

TVP_MSG_DECL(TVPCannotConnectMultipleWaveSoundBufferAtOnce,
	TJS_W(" WaveSoundBuffer ̃tB^œɎgp邱Ƃ͂ł܂"));

TVP_MSG_DECL(TVPInvalidWindowSizeMustBeIn64to32768,
	TJS_W("window  64`32768 ͈̔͂ 2 ̗ݏŖ΂Ȃ܂"));

TVP_MSG_DECL(TVPInvalidOverlapCountMustBeIn2to32,
	TJS_W("overlap  2`32 ͈̔͂ 2 ̗ݏŖ΂Ȃ܂"));

TVP_MSG_DECL(TVPKAGNoLine,
	TJS_W("ǂݍƂViIt@C %1 ͋ł"));

TVP_MSG_DECL(TVPKAGCannotOmmitFirstLabelName,
	TJS_W("ViIt@C̍ŏ̃x͏ȗł܂"));

TVP_MSG_DECL(TVPKAGLabelNotFound,
	TJS_W("ViIt@C %1 Ƀx %2 ܂"));

TVP_MSG_DECL(TVPKAGInlineScriptNotEnd,
	TJS_W("[endscript] ܂ @endscript ܂"));

TVP_MSG_DECL(TVPKAGSyntaxError,
	TJS_W("^O̕@G[łB'['  ']' ̑ΉA\"  \" ̑ΉAXy[X̓YA]ȉsAmacro ` endmacro ̑ΉAKvȑ̕sȂǂmFĂ"));

TVP_MSG_DECL(TVPKAGMacroEntityNotAvailable,
	TJS_W("}NGeBeB̓}NOł͎gpł܂"));

TVP_MSG_DECL(TVPKAGCallStackUnderflow,
	TJS_W("return ^O call ^OƑΉĂ܂ ( return ^O )"));

TVP_MSG_DECL(TVPKAGReturnLostSync,
	TJS_W("ViIt@CɕύX return ̖߂ʒuł܂"));

TVP_MSG_DECL(TVPKAGSpecifyKAGParser,
	TJS_W("KAGParser NX̃IuWFNgw肵Ă"));

TVP_MSG_DECL(TVPKAGMalformedSaveData,
	TJS_W("xf[^ُłBf[^jĂ\܂"));

TVP_MSG_DECL(TVPLabelOrScriptInMacro,
	TJS_W("x iscript ̓}NɋLqł܂"));

TVP_MSG_DECL(TVPUnknownMacroName,
	TJS_W("}N \"%1\" ͓o^Ă܂"));

//---------------------------------------------------------------------------
// Utility Functions
//---------------------------------------------------------------------------
TJS_EXP_FUNC_DEF(ttstr, TVPFormatMessage, (const tjs_char *msg, const ttstr & p1));
TJS_EXP_FUNC_DEF(ttstr, TVPFormatMessage, (const tjs_char *msg, const ttstr & p1,
	const ttstr & p2));
TJS_EXP_FUNC_DEF(void, TVPThrowExceptionMessage, (const tjs_char *msg));
TJS_EXP_FUNC_DEF(void, TVPThrowExceptionMessage, (const tjs_char *msg,
	const ttstr &p1, tjs_int num));
TJS_EXP_FUNC_DEF(void, TVPThrowExceptionMessage, (const tjs_char *msg, const ttstr &p1));
TJS_EXP_FUNC_DEF(void, TVPThrowExceptionMessage, (const tjs_char *msg,
	const ttstr & p1, const ttstr & p2));

TJS_EXP_FUNC_DEF(ttstr, TVPGetAboutString, ());
TJS_EXP_FUNC_DEF(ttstr, TVPGetVersionInformation, ());
TJS_EXP_FUNC_DEF(ttstr, TVPGetVersionString, ());

#define TVPThrowInternalError \
	TVPThrowExceptionMessage(TVPInternalError, __FILE__,  __LINE__)
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// version retrieving
//---------------------------------------------------------------------------
extern tjs_int TVPVersionMajor;
extern tjs_int TVPVersionMinor;
extern tjs_int TVPVersionRelease;
extern tjs_int TVPVersionBuild;
//---------------------------------------------------------------------------
extern void TVPGetVersion();
/*
	implement in each platforms;
	fill these four version field.
*/
//---------------------------------------------------------------------------
TJS_EXP_FUNC_DEF(void, TVPGetSystemVersion, (tjs_int &major, tjs_int &minor,
	tjs_int &release, tjs_int &build));
TJS_EXP_FUNC_DEF(void, TVPGetTJSVersion, (tjs_int &major, tjs_int &minor,
	tjs_int &release));
//---------------------------------------------------------------------------


#endif
